/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   program.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PROGRAM_H
#define UHDM_PROGRAM_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class program : public instance {
  public:
    // Implicit constructor used to initialize all members,
    // comment: program();
    ~program() final {}
    
    const BaseClass* VpiParent() const final { return vpiParent_; }

    bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    unsigned int UhdmParentType() const final { return uhdmParentType_; }

    bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    const std::string& VpiFile() const final;

    bool VpiFile(const std::string& data) final;

    unsigned int VpiLineNo() const final { return vpiLineNo_; }

    bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    unsigned int VpiIndex() const { return vpiIndex_; }

    bool VpiIndex(unsigned int data) { vpiIndex_ = data; return true;}

    unsigned int VpiType() { return vpiProgram; }

    const instance_array* Instance_array() const { return instance_array_; }

    bool Instance_array(instance_array* data) { instance_array_ = data; return true;}

    VectorOfprocess* Process() const { return process_; }

    bool Process(VectorOfprocess* data) { process_ = data; return true;}

    const clocking_block* Default_clocking() const { return default_clocking_; }

    bool Default_clocking(clocking_block* data) { default_clocking_ = data; return true;}

    VectorOfinterface* Interfaces() const { return interfaces_; }

    bool Interfaces(VectorOfinterface* data) { interfaces_ = data; return true;}

    VectorOfinterface_array* Interface_arrays() const { return interface_arrays_; }

    bool Interface_arrays(VectorOfinterface_array* data) { interface_arrays_ = data; return true;}

    VectorOfcont_assign* Cont_assigns() const { return cont_assigns_; }

    bool Cont_assigns(VectorOfcont_assign* data) { cont_assigns_ = data; return true;}

    VectorOfclocking_block* Clocking_blocks() const { return clocking_blocks_; }

    bool Clocking_blocks(VectorOfclocking_block* data) { clocking_blocks_ = data; return true;}

    VectorOfport* Ports() const { return ports_; }

    bool Ports(VectorOfport* data) { ports_ = data; return true;}

    const any* Expr_dist() const { return expr_dist_; }

    bool Expr_dist(any* data) {if (!expr_distGroupCompliant(data)) return false; expr_dist_ = data; return true;}

    UHDM_OBJECT_TYPE UhdmType() const final { return uhdmprogram; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    unsigned int vpiIndex_;

    instance_array* instance_array_;

    VectorOfprocess* process_;

    clocking_block* default_clocking_;

    VectorOfinterface* interfaces_;

    VectorOfinterface_array* interface_arrays_;

    VectorOfcont_assign* cont_assigns_;

    VectorOfclocking_block* clocking_blocks_;

    VectorOfport* ports_;

    any* expr_dist_;

  };

  
  class programFactory {
  friend Serializer;
  public:
  program* Make() {
    program* obj = new program();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<program*> objects_;
  };
  
  
  class VectorOfprogramFactory {
  friend Serializer;
  public:
  std::vector<program*>* Make() {
    std::vector<program*>* obj = new std::vector<program*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<program*>*> objects_;
  };

};

#endif

